<?php
/* 
Plugin Name: Genki Pre-Publish Reminder
Version: 1.4.1
Plugin URI: http://ericulous.com/2007/03/19/wp-plugin-genki-pre-publish-reminder/
Description: Display a pre-publish reminder tasklist on the Posts Admin Panel
Author: Genkisan
Author URI: http://ericulous.com
*/
load_plugin_textdomain('genki_prepublish');

add_action ('admin_menu', 'genki_pre_publish_reminder_menu');

function genki_pre_publish_reminder_menu() {
	add_option('genki_pre_publish_reminder_location', 1);
	add_option('genki_pre_publish_reminder_list', __('Enter your reminder list here.', 'genki_prepublish'));
	add_option('genki_pre_publish_reminder_bordercolor', '#e6db55');
	add_option('genki_pre_publish_reminder_bgcolor', '#ffffe0');
	
	if (get_option('genki_pre_publish_reminder_location') == '1') {
		$location = 'submitpost_box';
	}
	else {
		$location = 'edit_form_advanced';
	}
	
	add_action($location, 'genki_pre_publish_reminder_sidebar');
	
	if (function_exists('add_management_page')) {
		add_options_page('Pre-Publish Reminder', 'Pre-Publish Reminder', 8, __FILE__, 'genki_pre_publish_reminder_manage');
	}
}

function genki_pre_publish_reminder_sidebar() {
	$location = get_option('genki_pre_publish_reminder_location');
	$list = get_option('genki_pre_publish_reminder_list');
	$bordercolor = get_option('genki_pre_publish_reminder_bordercolor');
	$bgcolor = get_option('genki_pre_publish_reminder_bgcolor');

	if ($location == '1') {	?>
	<div style="margin: 0 0 15px 0; padding: 10px; border: 1px solid <?php echo $bordercolor; ?>; background: <?php echo $bgcolor; ?>;">
		<?php eval('?>'.genki_cmu_encode_xml(nl2br(stripslashes($list)))); ?>
	</div>
	<?php } else { ?>
	<div style="padding: 10px; border: 1px solid <?php echo $bordercolor; ?>; background: <?php echo $bgcolor; ?>;">
		<?php eval('?>'.genki_cmu_encode_xml(nl2br(stripslashes($list)))); ?>
	</div>
	<?php }
}

function genki_pre_publish_reminder_manage() {
if (isset($_POST['update_message'])) {

	?><div id="message" class="updated fade"><p><strong><?php

	update_option('genki_pre_publish_reminder_location', $_POST['location']);
	update_option('genki_pre_publish_reminder_list', $_POST['list']);
	update_option('genki_pre_publish_reminder_bordercolor', $_POST['bordercolor']);
	update_option('genki_pre_publish_reminder_bgcolor', $_POST['bgcolor']);

	echo __("Settings saved.","genki_prepublish");

	?></strong></p></div><?php
}

$location = get_option('genki_pre_publish_reminder_location');
$list = get_option('genki_pre_publish_reminder_list');
$bordercolor = get_option('genki_pre_publish_reminder_bordercolor');
$bgcolor = get_option('genki_pre_publish_reminder_bgcolor');
?>
	<div class="wrap">
	<?php screen_icon(); ?>
	<h2><?php _e('Pre-Publish Reminder', 'genki_prepublish'); ?></h2>
		<form name="formamt" method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
		
			<table class="form-table">
			<tr valign="top">
				<th scope="row"><label for="location"><?php _e('Display Location', 'genki_prepublish'); ?></label></th>
				<td>
					<input name="location" id="location" type="radio" value="1" <?php if ($location == '1') echo 'checked' ; ?>><?php _e('Post Sidebar', 'genki_prepublish'); ?></input><br />
					<input name="location" id="location" type="radio" value="0" <?php if ($location == '0') echo 'checked' ; ?>><?php _e('Below Post Textarea', 'genki_prepublish'); ?></input>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label for="bordercolor"><?php _e('Border Color', 'genki_prepublish'); ?></label></th>
				<td><input name="bordercolor" id="bordercolor" type="text" value="<?php echo $bordercolor; ?>" class="regular-text" /></td>
			</tr>
			<tr valign="top">
				<th scope="row"><label for="bgcolor"><?php _e('Background Color', 'genki_prepublish'); ?></label></th>
				<td><input name="bgcolor" id="bgcolor" type="text" value="<?php echo $bgcolor; ?>" class="regular-text" /></td>
			</tr>
			<tr valign="top">
				<th scope="row"><label for="timeon"><?php _e('Reminder List', 'genki_prepublish'); ?></label></th>
				<td>
					<textarea name="list" id="list" cols="120" rows="8" style="width: 100%;"><?php echo stripslashes($list); ?></textarea>
					<p><?php _e('HTML tags will be rendered as erm... html while php codes will be executed as erm... php codes.', 'genki_prepublish'); ?><br />
						<?php echo __('To display unformatted html or php, enclose them in the') . '&lt;code>&lt;/code>' . __('tag', 'genki_prepublish'); ?><br />
						<?php _e('e.g', 'genki_prepublish'); ?> &lt;code>&lt;a href="http://domain.com"><?php _e('text link', 'genki_prepublish'); ?>&lt;/a>&lt;/code></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label for="timeon"><?php _e('Preview', 'genki_prepublish'); ?></label></th>
				<td>
					<div style="margin: 0 0 15px 0; padding: 10px; border: 1px solid <?php echo $bordercolor; ?>; background: <?php echo $bgcolor; ?>;">
						<?php eval('?>'.genki_cmu_encode_xml(nl2br(stripslashes($list)))); ?>
					</div>
				</td>
			</tr>
			</table>

			<p><input class="button button-primary" type="submit" name="update_message" value="<?php _e('Save Changes', 'genki_prepublish'); ?>" /></p>
			<p><strong>Looking to change your theme? Visit <a href="http://ericulous.com/" title="Smashing Wordpress Themes">Smashing Wordpress Themes!</a></strong></p>
		</form>
	</div>
<?php
}

//functions from Code Markup Plugin
//http://www.thunderguy.com/semicolon/wordpress/code-markup-wordpress-plugin/

function genki_cmu_encode_xml($content) {
/*
	Look for <code> sections in the content and escape certain characters,
	depending on the allow and lang attributes.
	Also remove newlines after <code...> and before </code> so code displays
	nicely in <pre> blocks.
*/
	return preg_replace_callback('!<code([^>]*)>(?:\r\n|\n|\r|)(.*?)(?:\r\n|\n|\r|)</code>!ims', 'genki_cmu_encode_xml_callback', $content);
}

// ===== Callback functions ==================================================

function genki_cmu_encode_xml_callback($matches) {
/*
	Encode XML in a <code> tag.
*/
	$attributes = $matches[1];
	$escapedContent = $matches[2];

	// Escape html special chars
	$escapedContent = htmlspecialchars($escapedContent, ENT_NOQUOTES);
	return "<code$attributes>$escapedContent</code>";
}

function genki_cmu_unescape_qq_callback($matches) {
/*
	Unescape double quotes in a <pre> tag.
*/
	return "<pre{$matches[1]}>".str_replace('\"', '"', $matches[2])."</pre>";
}

function genki_cmu_untexturize_code_callback($matches) {
/*
	Undo the effect of wptexturize() within a <code> element.
	wptexturize() is meant to handle this but is buggy...
	BUGS: Turns --- into -- and `` into "
*/
	$fancy = array('&#215;', '&#8216;', '&#8217;', '&#8242;', '&#8220;', '&#8221;', '&#8243;', '&#8212;', '&#8211;', '&#8230;', '&#8220;');
	$plain = array('x'     ,'\''     , '\''     , '\''     , '"'      , '"'      , '"'      , '--'     , '--'     , '...'    , '``'     );
	return "<code{$matches[1]}>".str_replace($fancy, $plain, $matches[2])."</code>";
}
?>